let express = require("express");
let ipaddr = require("ipaddr.js");
let db = require("../libs/Database").instance();
let router = express.Router();

function combineToList(a, b) {
    return a + "\n" + b;
}

function toList(array) {
    return array.reduce(combineToList, "").trim();
}

router.use((req, res, next) => {
    res.type('text/plain');
	next();
});

router.get("/", (req, res) => {
    db.q.select("fqdn").from("addresses").list((e, d) => {
        res.send(toList(d))
    });
});

router.get("/:fqdn", (req, res) => {
    db.q.select(["ipv4", "ipv6"]).from("addresses").filter("fqdn", req.params.fqdn).first((e, d) => {
		if (e) return res.status(400).send("Error");
		if (!d) return res.status(404).send("Unknown FQDN");
		res.send(d.ipv4 ? (d.ipv6 ? d.ipv4 + "\n" + d.ipv6 : d.ipv4) : (d.ipv6 ? d.ipv6 : ""));
	});
});

router.get("/:fqdn/:code", (req, res) => {
	let addr = ipaddr.parse(req.ip);
    if (!["ipv4", "ipv6"].includes(addr.kind())) return res.status(400).send("Invalid ip address");
    db.query("UPDATE addresses SET " + addr.kind() + " = ? WHERE fqdn = ? AND code = ?", [addr.toString(), req.params.fqdn, req.params.code], (e, d) => {
		if (e) return res.status(400).send("Error");
		res.send(d);
	});
});

module.exports = router;
